#!/usr/bin/perl -w
use strict;
use IO::Uncompress::Gunzip qw(gunzip $GunzipError) ;
use Time::Local;
use Time::HiRes qw(gettimeofday tv_interval);
use DBI;
use Getopt::Long;


sub get_connection($$$) {
  my $dsn  = shift;
  my $user = shift;
  my $pass = shift;

  my $dbh = DBI->connect($dsn, $user, $pass,  {RaiseError => 1, PrintError => 1});
 
  if (!defined($dbh)) {
    print  "Cannot connect to $dsn as $user\n";
    die();
  }
  
  return $dbh;
}
############################################
#MODIFY HERE TO MATCH YOUR CPNFIGURATION
    my $host="192.168.0.35";
    my $port="3306";
    my $user="restore";
    my $password="restore";
    my $key = "test4";
    my $filepath="/home/mysql/backups/test4_14_2_2014";
############################################  
    
    my $TableObjectLoc ='tbtest1';
    
    my $dbh = get_connection("DBI:mysql:host=${host};port=${port}","${user}","${password}");
    my @files=($filepath."/tbtest1#chunk_1.gz",$filepath."/tbtest1#chunk_2.gz");
    my $irows = 0;
    
###############################################   
#CHANGE THE AUTOCOMMIT HERE   
    $dbh->do('SET autocommit=0');
############################################### 
    $dbh->do('SET FOREIGN_KEY_CHECKS=0');
    $dbh->do('SET UNIQUE_CHECKS=0');

    my $mysql = "mysql  -h${host} -u${user} -p${password} -P${port} -D ${key} < ${filepath}/test4.sql";
    print " ===========\n" . $mysql . "\n===========\n" ;
    no warnings 'all';
    print qx($mysql);
    
    print   "Processing Table = ".$TableObjectLoc."\n";

    foreach my $file ( sort @files ) {            
        my $tableFile ='';
        my $tableName = '';
        my $extention = "";
        

        $extention = substr($file,index($file,'.')+1,length($file));
        if($extention eq "gz"){
            my $filedest = substr($file,0,index($file,'.')).".csv";
            gunzip  "${file}" => "${filedest}" or die "gzip failed: $GunzipError\n";
            $file = $filedest;
        }
            my $index = index($file,'.');
            
            
            if(index($file,'#') > 0){
                $index = index($file,'#');
                print "Processing  Chunk file $file\n";
            }
            $tableName = substr($file,0,$index);
            $tableFile = $file;        

            my $row = undef;
            print "\nLOAD DATA INFILE '${tableFile}' IGNORE INTO TABLE ${key}.$TableObjectLoc  FIELDS TERMINATED BY ',' OPTIONALLY ENCLOSED BY '\"' LINES TERMINATED BY '\\r\\n'\n" ;     
            
            my $cmd = "LOAD DATA INFILE '${tableFile}' IGNORE INTO TABLE ${key}.$TableObjectLoc  FIELDS TERMINATED BY ',' OPTIONALLY ENCLOSED BY '\"' LINES TERMINATED BY '\\r\\n'" ;



            #$cmd = "SELECT COLUMN_NAME, Data_TYPE, NUMERIC_PRECISION, CHARACTER_MAXIMUM_LENGTH FROM information_schema.COLUMNS where table_schema='$key' and table_name='$dimTable'";
            my $time = localtime;
            print "processing = ".$TableObjectLoc." [start] at $time \n";
            $row = $dbh->do($cmd);
            if(defined($row))
            {
                print "Processed row(s) = ".$row;
            }
            $time = localtime;
            print "\nprocessing = ".$TableObjectLoc." [ends] at $time \n\n";
            if($extention eq "gz"){
                unlink "${file}";
            }
        
            if(defined($row) && $row > 0E0 )
            {
                $irows = $irows + $row;
            }
    }
    #sleep 30;
    print "number of row processed by the LOAD ".$irows."\n";
    $dbh->do('SET UNIQUE_CHECKS=0');
    $dbh->do('SET FOREIGN_KEY_CHECKS=1');
    $dbh->do('SET autocommit=1');

